Scriptname SOTSleepMCM extends SKI_ConfigBase 



Event OnConfigInit()
Pages = New String[1]
	Pages[0] = "Encounter Settings"
		SafePreset = new string[6]
	SafePreset[0] = "Marker 1"
	SafePreset[1] = "Marker 2"
	SafePreset[2] = "Marker 3"
	SafePreset[3] = "Marker 4"
	SafePreset[4] = "Marker 5"
	SafePreset[5] = "Marker 6"
EndEvent

Event OnPageReset(String a_page)
if (a_page == "")
		LoadCustomContent("skyui/SleepingModule.dds", 0, 0)
		return
	else
		UnloadCustomContent()
	endIf
SetCursorFillMode(TOP_TO_BOTTOM)
If (a_page == "Encounter Settings")
AddHeaderOption("Sleeping Encounters (Scroll Down)")
		AddEmptyOption()
		SleepDungeon = AddSliderOption("Dungeon Ambush Odds", DungeonChance.getvalueint())
		AddEmptyOption()
		SleepCollege = AddSliderOption("College Ambush Odds", College.getvalueint())
		AddEmptyOption()
		SleepJorrvaskr = AddSliderOption("Jorrvaskr Hall HQ", Jorrsod.getvalueint())
		AddEmptyOption()
		SleepInn = AddSliderOption("Inn Ambush Odds", DreamsInn.getvalueint())
		AddEmptyOption()
		SleepDraugr = AddSliderOption("Draugr Keep Ambush Odds", DraugrKeep.getvalueint())
		AddEmptyOption()
		SleepOther = AddSliderOption("All Other Places", AllOther.getvalueint())
		SetCursorPosition(1)
		AddHeaderOption("Other Settings")
		AddEmptyOption()
		SOT_Drowsy = AddToggleOption("Allow Drowsy Effect", SOT_DrowsyStatus)
		AddEmptyOption()
		AddHeaderOption("Mark up to 6 Spots Safe for Sleep")
		AddEmptyOption()
		Safetype = AddMenuOption("Mark Safe", SafePreset[SafeIndex])
		AddEmptyOption()
		SOT_Messages = AddToggleOption("Allow Encounter Notification", SOT_MessagesStatus)
		AddEmptyOption()
		SOT_firstperson = AddToggleOption("Allow Forced 1st Person View", SOT_firstpersonStatus)
		AddEmptyOption()
		delay = AddSliderOption("Combat Delay While Waking Up", sotdelay.getvalueint())
EndIf
EndEvent

event OnOptionMenuOpen(int option)
		
	if (option == Safetype)
		SetMenuDialogOptions(SafePreset)
		SetMenuDialogStartIndex(SafeIndex)
		SetMenuDialogDefaultIndex(0)
	endIf
	
endEvent

event OnOptionMenuAccept(int option, int index)
	if (option == SafeType)
		SafeIndex = index
if index == 0
SetMenuOptionValue(Safetype, SafePreset[SafeIndex])
	ElseIf index == 1
SafePlace.MoveTo(playerref)
SetMenuOptionValue(SafeType, SafePreset[SafeIndex])
ElseIf index == 2
SafePlace2.MoveTo(playerref)
SetMenuOptionValue(SafeType, SafePreset[SafeIndex])
ElseIf index == 3
SafePlace3.MoveTo(playerref)
SetMenuOptionValue(SafeType, SafePreset[SafeIndex])
ElseIf index == 4
SafePlace4.MoveTo(playerref)
SetMenuOptionValue(SafeType, SafePreset[SafeIndex])
ElseIf index == 5
SafePlace5.MoveTo(playerref)
SetMenuOptionValue(SafeType, SafePreset[SafeIndex])
ElseIf index == 6
SafePlace6.MoveTo(playerref)
SetMenuOptionValue(SafeType, SafePreset[SafeIndex])
	endIf
	EndIf	

EndEvent

event OnOptionSliderOpen(int a_option)    ; SLIDERS

if (a_option == SleepDungeon)
SetSliderDialogStartValue(DungeonChance.getvalueint())
SetSliderDialogDefaultValue(40)
SetSliderDialogRange(0, 100)
SetSliderDialogInterval(1)
EndIf

if (a_option == SleepCollege)
SetSliderDialogStartValue(College.getvalueint())
SetSliderDialogDefaultValue(10)
SetSliderDialogRange(0, 100)
SetSliderDialogInterval(1)
EndIf

if (a_option == SleepJorrvaskr)
SetSliderDialogStartValue(JorrSOD.getvalueint())
SetSliderDialogDefaultValue(10)
SetSliderDialogRange(0, 100)
SetSliderDialogInterval(1)
EndIf

if (a_option == SleepInn)
SetSliderDialogStartValue(DreamsInn.getvalueint())
SetSliderDialogDefaultValue(10)
SetSliderDialogRange(0, 100)
SetSliderDialogInterval(1)
EndIf

if (a_option == SleepDraugr)
SetSliderDialogStartValue(DraugrKeep.getvalueint())
SetSliderDialogDefaultValue(45)
SetSliderDialogRange(0, 100)
SetSliderDialogInterval(1)
EndIf

if (a_option == SleepOther)
SetSliderDialogStartValue(AllOther.getvalueint())
SetSliderDialogDefaultValue(20)
SetSliderDialogRange(0, 100)
SetSliderDialogInterval(1)
EndIf

if (a_option == delay)
SetSliderDialogStartValue(sotdelay.getvalueint())
SetSliderDialogDefaultValue(0)
SetSliderDialogRange(0, 10)
SetSliderDialogInterval(1)
EndIf

EndEvent

event OnOptionSliderAccept(int a_option, float a_value)

if (a_option == SleepDungeon)  ;  Set odds of ambush while sleeping in dungeon
SleepDungeon_A = a_value as Int
SetSliderOptionValue(a_option, a_value)
Dungeonchance.setvalueint(SleepDungeon_A)
EndIf

if (a_option == SleepCollege)  ;  Set odds of ambush while sleeping in a college
SleepCollege_A = a_value as Int
SetSliderOptionValue(a_option, a_value)
College.setvalueint(SleepCollege_A)
EndIf

if (a_option == SleepJorrvaskr)  ;  Set odds of ambush while sleeping in Jorrvaskr HQ
SleepJorrvaskr_A = a_value as Int
SetSliderOptionValue(a_option, a_value)
JorrSOD.setvalueint(SleepJorrvaskr_A)
EndIf

if (a_option == SleepInn)  ;  Set odds of ambush while sleeping in an Inn
SleepInn_A = a_value as Int
SetSliderOptionValue(a_option, a_value)
DreamsInn.setvalueint(SleepInn_A)
EndIf

if (a_option == SleepDraugr)  ;  Set odds of ambush while sleeping in a Draugr Keep
SleepDraugr_A = a_value as Int
SetSliderOptionValue(a_option, a_value)
DraugrKeep.setvalueint(SleepDraugr_A)
EndIf

if (a_option == SleepOther)  ;  Set odds of ambush while sleeping in all other places
SleepOther_A = a_value as Int
SetSliderOptionValue(a_option, a_value)
AllOther.setvalueint(SleepOther_A)
EndIf

if (a_option == delay)  ;  Seconds before being attacked
delay_A = a_value as Int
SetSliderOptionValue(a_option, a_value)
sotdelay.setvalueint(delay_A)
EndIf



EndEvent

Event OnOptionDefault(Int a_option)             ; TOGGLE
		If (a_option == SOT_Drowsy)
		MiscStatus = False
		SetToggleOptionValue(a_option, MiscStatus)
		Punish.SetValueInt(0)
		EndIf
		
			If (a_option == SOT_messages)
		sot_messagesStatus = True
		SetToggleOptionValue(a_option, sot_messagesStatus)
		messages.SetValueInt(5)
		EndIf
		
			If (a_option == SOT_firstperson)
		sot_firstpersonStatus = True
		SetToggleOptionValue(a_option, sot_firstpersonStatus)
		firstperson.SetValueInt(0)
		EndIf


		EndEvent

Event OnOptionSelect(Int a_option)
									If (a_option == SOT_Drowsy)
SOT_DrowsyStatus = !SOT_DrowsyStatus
	SetToggleOptionValue(a_option, SOT_DrowsyStatus)
	If SOT_DrowsyStatus == True 
		HardToWake.SetValueInt(0)
	Else
	    HardToWake.SetValueInt(5)
	EndIf
	EndIf	
	
	If (a_option == SOT_messages)
SOT_messagesStatus = !SOT_messagesStatus
	SetToggleOptionValue(a_option, SOT_messagesStatus)
	If SOT_messagesStatus == True 
		messages.SetValueInt(5)
	Else
	    messages.SetValueInt(0)
	EndIf
	EndIf
	
		If (a_option == SOT_firstperson)
SOT_firstpersonStatus = !SOT_firstpersonStatus
	SetToggleOptionValue(a_option, SOT_firstpersonStatus)
	If SOT_firstpersonStatus == True 
		firstperson.SetValueInt(0)
	Else
	    firstperson.SetValueInt(5)
	EndIf
	EndIf
	
	EndEvent

Event OnOptionHighlight(Int a_option)

If (a_option == delay) 
		SetInfoText("How Many Seconds After Waking Up Before Enemy Can Attack")
	EndIf

If (a_option == SOT_firstperson) 
		SetInfoText("Wether to allow Forced First Person View When Waking Up.")
	EndIf

If (a_option == SOT_Messages) 
		SetInfoText("Wether to allow notification of attack.  A pop up window will announce the Ambush.")
	EndIf


If (a_option == SafeType) 
		SetInfoText("Will mark a small room or sleeping area as encounter free when sleeping.  Useful for a custom player home. 6 Safe Locations are provided. Please select any of the 6 to set this location as safe.")
	EndIf

	If (a_option == SOT_Drowsy) 
		SetInfoText("When the player wakes up, and if laying on bed animations are not enabled, the player will be drowsy and sluggish to respond for a second.")
	EndIf

If (a_option == SleepOther) 
		SetInfoText("Set The Odds From 0 to 100 for Getting Ambushed While Sleeping In All Other Places.")
	EndIf

If (a_option == SleepDraugr) 
		SetInfoText("Set The Odds From 0 to 100 for Getting Ambushed While Sleeping In a Draugr Keep.")
	EndIf

If (a_option == SleepInn) 
		SetInfoText("Set The Odds From 0 to 100 for Getting Ambushed While Sleeping In a Inn.")
	EndIf

If (a_option == SleepJorrvaskr) 
		SetInfoText("Set The Odds From 0 to 100 for Getting Ambushed While Sleeping In Jorrvaskr HQ.")
	EndIf

If (a_option == SleepCollege) 
		SetInfoText("Set The Odds From 0 to 100 for Getting Ambushed While Sleeping In the Mages College.")
	EndIf

If (a_option == SleepDungeon) 
		SetInfoText("Set The Odds From 0 to 100 for Getting Ambushed While Sleeping In a Dungeon.")
	EndIf


EndEvent

Actor Property PlayerRef  Auto
string[] SafePreset
Bool MiscStatus = False
GlobalVariable Property allother Auto  
GlobalVariable Property college Auto
GlobalVariable Property Debugsot Auto
GlobalVariable Property disturbsleep Auto
GlobalVariable Property DraugrKeep Auto
GlobalVariable Property DreamsInn Auto
GlobalVariable Property DungeonChance Auto
GlobalVariable Property FTravelOdds Auto
GlobalVariable Property Hardtowake Auto
GlobalVariable Property Jorrsod Auto
GlobalVariable Property kill35 Auto
GlobalVariable Property lore Auto
GlobalVariable Property messages Auto
GlobalVariable Property Playerfollowercount Auto
GlobalVariable Property Playerisvampire Auto
GlobalVariable Property Playeriswerewolf Auto
GlobalVariable Property SotSleepanime Auto
GlobalVariable Property punish Auto
Int SafeType
Int SafeIndex = 0 ; safe sleeping areas
Int SleepDungeon
Int SleepDungeon_A
Int SleepCollege
Int SleepCollege_A
Int SleepJorrvaskr
Int SleepJorrvaskr_A
Int SleepInn
Int SleepInn_A
Int SleepDraugr
Int SleepDraugr_A
Int SleepOther
Int SleepOther_A
Int SOT_Drowsy
Bool SOT_DrowsyStatus = True  ; allow drowsy effect
iNT sot_messages
Bool Sot_messagesStatus = True ; allow messages
int sot_firstperson  ; forced first person when waking
Bool sot_firstpersonstatus = True
int delay
int delay_A

ObjectReference Property SafePlace  Auto  

ObjectReference Property SafePlace2  Auto  

ObjectReference Property SafePlace3  Auto  

ObjectReference Property SafePlace4  Auto  

ObjectReference Property SafePlace5  Auto  

ObjectReference Property SafePlace6  Auto  


GlobalVariable Property FirstPerson  Auto  

GlobalVariable Property sotdelay  Auto  
